<template>
  <div>
    <v-card flat class="pa-10">
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <v-row>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          Nombre
          <span class="tRojo">*</span>
          <br />
          <v-text-field
            v-model.trim="vista.nombre"
            outlined
            solo
            maxlength="50"
            flat
            dense
            :error="$v.vista.nombre.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(vista.nombre, 50)
            "
            background-color="white"
          >
            <template v-if="$v.vista.nombre.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.vista.nombre.$reset" v-close-popover>
                    <div v-if="!$v.vista.nombre.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-text-field>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          Ruta
          <span class="tRojo">*</span>
          <br />
          <Rutas :validator="$v" v-model="vista.idRuta" />
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          Descripción
          <span class="tRojo">*</span>
          <br />
          <v-textarea
            v-model.trim="vista.descripcion"
            outlined
            solo
            maxlength="200"
            flat
            dense
            row-height="4"
            no-resize
            :error="$v.vista.descripcion.error"
            hint-align="right"
            :hint="
              'CARACTERES RESTANTES ' +
                serviceCommons.remaningCharacters(vista.descripcion, 200)
            "
            background-color="white"
          >
            <template v-if="$v.vista.descripcion.$error" v-slot:append>
              <v-popover placement="bottom-end" color="red" offset="16">
                <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                <template slot="popover">
                  <div @click="$v.vista.descripcion.$reset" v-close-popover>
                    <div v-if="!$v.vista.descripcion.required">
                      ¡No te olvides de éste campo!
                    </div>
                  </div>
                </template>
              </v-popover>
            </template>
          </v-textarea>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          Imagen
          <span class="tRojo">*</span>
          <br />
          <Imagenes :validator="$v" v-model="vista.imagen" />
        </v-col>
      </v-row>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingVista },
            { 'error-validation-btn': $v.$invalid },
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </v-card>
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh!</strong>
            Tienes algunos conflictos de validación
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡No hay de que preocuparse! Solo tienes que corregirlos
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh! Advertencia</strong>
            <v-icon right color="red">mdi-alert-circle</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh...! </strong>
            Todo todo ha salio bien
            <v-icon right color="green">mdi-check-circle-outline</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡Tus datos fueron guardados!
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="selectNode($event)"
                >Entiendo</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.categorias {
  height: 48px;
}
.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.ponderacion .fixed.tooltiptext3 .fixed.tooltiptext4 {
  bottom: -15px;
  left: -40px;
}
.ponderacion .tooltiptext3 .tooltiptext4 {
  bottom: -40px;
  left: -60px;
}
.titSec .tooltiptext3 .tooltiptext4 {
  bottom: -30px;
  left: -40px;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import store from "@/store";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
import Rutas from "@/views/secure/accesos/sistema/mapa-sitio/vistas/components/Rutas.vue";
import Imagenes from "@/views/secure/accesos/sistema/mapa-sitio/vistas/components/Imagenes.vue";
import { required } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
const nodeTemplate = {
  id: null,
  text: null,
  data: {
    idVista: null,
    idVistaPadre: null,
    nombre: null,
    descripcion: null,
    imagen: null,
    idRuta: null,
  },
  state: {
    selected: false,
  },
};
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-DatosVista",
  components: {
    LeavePage,
    Rutas,
    Imagenes,
  },
  props: ["mode", "vistaIn", "parent", "instanceTree"],
  data() {
    return {
      savingVista: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      vistaBackup: {
        idVista: null,
        nombre: "",
      },
      vista: {
        idVista: null,
        nombre: "",
      },
    };
  },
  validations: {
    vista: {
      nombre: {
        required,
      },
      descripcion: {
        required,
      },
      idRuta: {
        required,
      },
      imagen: {
        required,
      },
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.vistaBackup) {
        const originalValue = JSON.stringify(this.vistaBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.vista).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.vista.idVista === undefined;
      }
    },
  },
  methods: {
    selectNode($event) {
      if (this.parent) {
        this.parent.expand();
        this.parent.unselect();
      }
      if (this.currentNode) {
        this.currentNode.unselect();
        this.currentNode.select($event);
      }
      this.dialogSave = false;
    },
    guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        this.savingVista = true;
        if (this.mode == 0) {
          this.vista.idVistaPadre = 0;
          delete this.vista.idVista;
          axios
            .post("/accesos/sistema/vistas/v1/", this.vista)
            .then((response) => {
              let data = response.data;
              if (data) {
                this.vista.idVista = data.resultado.id;
              }
              this.vistaBackup = JSON.parse(JSON.stringify(this.vista));
              nodeTemplate.id = this.vista.idVista;
              nodeTemplate.text = this.vista.nombre;
              nodeTemplate.data = this.vista;
              this.instanceTree.append(nodeTemplate);
              this.currentNode = this.instanceTree.tree.model[0];
              this.dialogSave = true;
            })
            .catch((error) => {
              if (error.response) {
                console.log(error.response.data);
              }
            })
            .finally(() => {
              this.savingVista = false;
            });
        } else if (this.mode == 1) {
          this.vista.idVistaPadre = this.parent.data.idVista;
          axios
            .post("/accesos/sistema/vistas/v1/", this.vista)
            .then((response) => {
              let data = response.data;
              if (data) {
                this.vista.idVista = data.resultado.id;
              }
              this.vistaBackup = JSON.parse(JSON.stringify(this.vista));
              nodeTemplate.id = this.vista.idVista;
              nodeTemplate.text = this.vista.nombre;
              nodeTemplate.data = this.vista;
              this.parent.append(nodeTemplate);
              this.currentNode = this.parent.children.filter(
                (node) => node.id == this.vista.idVista
              )[0];
              this.dialogSave = true;
            })
            .catch((error) => {
              if (error.response) {
                console.log(error.response.data);
              }
            })
            .finally(() => {
              this.savingVista = false;
            });
        } else if (this.mode == 2) {
          let body = JSON.parse(JSON.stringify(this.vista));
          delete body.text;
          delete body.idVista;
          axios
            .put("/accesos/sistema/vistas/v1/" + this.vista.idVista, body)
            .then((response) => {
              this.vistaBackup = JSON.parse(JSON.stringify(this.vista));
              this.vistaIn.data = this.vista;
              this.vistaIn.text = this.vista.nombre;
              this.currentNode = this.vistaIn;
              this.dialogSave = true;
            })
            .catch((error) => {
              if (error.response) {
                console.log(error.response.data);
              }
            })
            .finally(() => {
              this.savingVista = false;
            });
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    cancelGlobalChanges() {
      this.vista = JSON.parse(JSON.stringify(this.vistaBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
  },
  created() {
    if (this.mode == 2) {
      this.vista = JSON.parse(JSON.stringify(this.vistaIn.data));
      this.vistaBackup = JSON.parse(JSON.stringify(this.vista));
    }
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  },
};
</script>
